%% MLE %%
fun=@(theta)comp_loglike_gilleskie(theta,theta4_fixed,theta5_fixed,n_decision, G, beta,...
    Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,...
    Z_1_Jp2toD,Z_2_Jp2toD,Z_3_Jp2toD,Z_0_Jp2toD);

A = [];b = [];Aeq = [];beq = [];lb = [];ub = [];nonlcon = [];
x0 =[theta1_fixed theta2_fixed theta3_fixed theta6_dgp]+1.5*rand;
options = optimoptions(@fmincon,'Display','iter','StepTolerance',10^-3);

[theta_mle,fval,exitflag,output,lambda,grad,hessian] =fmincon(fun,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);

se_mle=sqrt( diag( inv(hessian) ) );

LB_theta_mle=theta_mle'-1.96*se_mle;
UB_theta_mle=theta_mle'+1.96*se_mle;
[LB_theta_mle,theta_mle',UB_theta_mle]

%  I-2. E(v) and E(a) for MLE
cf_flag=0;
[Ev_mle, Ea_mle]=comp_ev_ea_mle(theta_mle,hessian,cf_flag,...
                            theta4_fixed,theta5_fixed,...
                            Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,PC,Y,L,phi,K,T,eta,H,G,beta);

LB_Ev_mle=Ev_mle(1);
mean_Ev_mle=Ev_mle(2);
UB_Ev_mle=Ev_mle(3);
[LB_Ev_mle,mean_Ev_mle,UB_Ev_mle]
%len=UB_Ev_mle-LB_Ev_mle
%Ev_true

LB_Ea_mle=Ea_mle(1);
mean_Ea_mle=Ea_mle(2);
UB_Ea_mle=Ea_mle(3);
%[LB_Ea_mle,mean_Ea_mle,UB_Ea_mle]
%len=UB_Ea_mle-LB_Ea_mle
%Ea_true

% II. Counterfactual 
% 1. Experiment 1
cf_flag=1;
[Ev_mle_cf_exp1, Ea_mle_cf_exp1]=comp_ev_ea_mle(theta_mle,hessian,cf_flag,...
                            theta4_fixed,theta5_fixed,...
                            Z_1_1toJp1,Z_2_1toJp1,Z_3_1toJp1,Z_0_1toJp1,PC,Y,L,phi,K,T,eta,H,G,beta);

LB_Ev_mle_cf_exp1=Ev_mle_cf_exp1(1);
mean_Ev_mle_cf_exp1=Ev_mle_cf_exp1(2);
UB_Ev_mle_cf_exp1=Ev_mle_cf_exp1(3);
[LB_Ev_mle_cf_exp1,mean_Ev_mle_cf_exp1,UB_Ev_mle_cf_exp1]
%len=UB_Ev_mle_cf_exp1-LB_Ev_mle_cf_exp1
%Ev_cf_exp1_true


LB_Ea_mle_cf_exp1=Ea_mle_cf_exp1(1);
mean_Ea_mle_cf_exp1=Ea_mle_cf_exp1(2);
UB_Ea_mle_cf_exp1=Ea_mle_cf_exp1(3);
%[LB_Ea_mle_cf_exp1,mean_Ea_mle_cf_exp1,UB_Ea_mle_cf_exp1]
%len=UB_Ea_mle_cf_exp1-LB_Ea_mle_cf_exp1
%Ea_cf_exp1_true
