function [D,F,E1]=comp_DF(v,mu,sigma,A,G,J,K,m)
E1 = ( reshape(repmat(reshape(v,J*K,1),1,m)',K*m,J)  + repmat(mu',K,1) )./repmat(sigma,K,J);
E2=reshape(repmat(reshape(       A,        m*K,1),J,1),K*m,J);
D = E1-E2;

ind_col=reshape((repmat(1:J:1+(K-1)*J,J,1)+[0:1:(J-1)]')',1,J*K);
ind_row=reshape((repmat(1:m:1+(K*K-1)*m,m,1)+[0:1:(m-1)]')',1,m*K*K);

Gmat=G((K+1):end,:);
mat1=kron(reshape(reshape(Gmat,K*J*K,1),K,K*J),ones(m,1)).*repmat(exp(D),1,K);
%mat1=[reshape(1:12,6,2),reshape(1:12,6,2)+10,reshape(1:12,6,2)+20]
mat2=sum(reshape(mat1(:,ind_col),K*m*K,J),2);
F=reshape(mat2(ind_row),K,K,m);
end 

