% Y=labor income 
% PC=cost of a medical visit
% L=1(sick leave coverage)
function Cd=construct_Cd(d,T,prices,phi)
K=1+1+sum( (2:1:T).^2 );
x_tva=construct_x_tva(T); % K by 1

Cd=zeros(K,1);
for i=1:K
    x=x_tva(i,2:4);
    Cd(i)=consumption(x,d,prices,phi);
end 



end 


%{
for v=0:T-2
    for a=0:T-2
        x=find_x(v,a,T);
        Cd(x)=consumption(a,d,1,Y);
    end 
end 

a=T-1;
for v=0:T-2
 x=find_x(v,a,T);
 Cd(x)=consumption(a,d,1,Y);
end

v=T-1;
for a=0:T-1
 x=find_x(v,a,T);
 Cd(x)=consumption(a,d,1,Y);    
end 

%} 


