% Construct G^d; d=0,1,2,3
%{
% Check 
clear;
d=3;T=3;
Gd=construct_Gd(d,T,eta,delta,H) ;
% Create names 
x_tva=construct_x_tva(T);
mat=x_tva(:,2:4);
new=100*mat(:,1)+10*mat(:,2)+mat(:,3);
name={};
for j=1:length(new)
name{j} = sprintf('%03d',new(j));
end 
name=matlab.lang.makeValidName(string(name))
sTable = array2table(Gd,'RowNames',name,'VariableNames',name)
%}

function Gd=construct_Gd(d,T,eta,delta,H) 

K=1+1+sum( (2:1:T).^2 );
Gd=zeros(K,K);

pi_s=costruct_pi_s(delta,H);
Gd(:,1)=1;
Gd(1,1)=1-pi_s;
Gd(1,2)=pi_s;

% The 1st column 
% For t=1:T-1, the first colum is pi_w
for t=1:T-1
    for v=0:t-1
        for a=0:t-1
           x=find_x(t,v,a); 
           pi_w=costruct_pi_w(t,v,a,d,eta,H);
           Gd(x,1)= pi_w;
        end 
    end 
end 

for t=1:T-1
    for v=0:t-1
        for a=0:t-1
            x=find_x(t,v,a);
            v_new=v+(d==1 | d==3);
            a_new=a+(d==2 | d==3);
            x_new=find_x(t+1,v_new,a_new);
            pi_w=costruct_pi_w(t,v,a,d,eta,H);
            Gd(x,x_new)=1-pi_w;
        end 
    end 
end 
   
    
end 