
%eta0=-2.9;eta1=0.003;eta2=-0.0004;eta3=0.0065;eta4=0.0007;eta5=0.0003;
%eta6=0.5722;eta7=-0.07;eta8=0.003;eta9=-0.05;eta10=-0.11;eta11=-0.01;
%eta=[eta0,eta1,eta2,eta3,eta4,eta5,eta6,eta7,eta8,eta9,eta10,eta11]';
%t=1;v=2;a=1;d=1;
function pi_w=costruct_pi_w(t,v,a,d,eta,H)

v_new=v+(d==1 | d==3);
a_new=a+(d==2 | d==3);

eta0=eta(1);
eta1=eta(2);
eta2=eta(3);
eta3=eta(4);
eta4=eta(5);
eta5=eta(6);
eta6=eta(7);
eta7=eta(8);
eta8=eta(9);
eta9=eta(10);
eta10=eta(11);
eta11=eta(12);

eta_E=eta0+...
eta1*v_new+eta2*(v_new^2)+...
eta3*a_new+eta4*(a_new^2)+...
eta5*v_new*a_new+...
eta6*t+eta7*(t^2)+eta8*(t^3)+...
eta9*H(1)+eta10*H(2)+eta11*H(3);

pi_w=exp(eta_E)/( 1 + exp(eta_E) );


end 
