% Input: theta_{1:m}  = para_trans
%        
% Given (m,theta_{1:m}), draw new data from likelidhood 
function n_decision=simulate_data(para_trans,m,beta,G,K,J,S,include_u,theta_fixed,n_large) 
 
para=trans_inv_var(para_trans',m,J,S,include_u);
Nomega          = m;
Nmu             = J*m;
Nsigma          = m;
Nsigma_common   = 1;
Ntheta_Jp2toD   = S;
N1              = Nomega;
N2              = Nomega+Nmu;
N3              = Nomega+Nmu+Nsigma;
N4              = Nomega+Nmu+Nsigma+Nsigma_common;
N5              = Nomega+Nmu+Nsigma+Nsigma_common+Ntheta_Jp2toD;

omega           = para(1:N1,:);
mu_vec          = para(1+N1:N2,:);mu=reshape(mu_vec',m,J)';
sigma           = para(1+N2:N3,:);
sigma_common    = para(1+N3:N4,:);
if include_u==1
theta_Jp2toD    = para(1+N4:N5,:);
end 
 

% Define u_mat 
if J>1 && include_u==1
    u1 = theta_fixed(1) + theta_fixed(3) *(1:K)';
    u2 = theta_fixed(2) + theta_Jp2toD(1)*(1:K)';  
    u0 =                  theta_Jp2toD(2)*(1:K)';
    u_mat=[u0,u1,u2];
%elseif J==2 && include_u==0
%    u1 = theta_fixed(1)            + theta_fixed(3)*(1:K)'; 
%    u2 = theta_fixed(2)*ones(K,1);  
%    u0 = zeros(K,1);
%    u_mat=[u0,u1,u2];   
elseif  J==1 && include_u==0
    u1 = theta_fixed(1) + theta_fixed(2)*(1:K)'; 
    u0 = zeros(K,1);
    u_mat=[u0,u1];
end 
% Compute CCPs
[~,~,~,ccp] = solveDP_evmix_NK(u_mat,G,mu,sigma,omega,beta,50,100000,zeros(K,1));


%( sum(ccp,2) == 1 )
% ( ccp >0 )
%ccp= ccp./sum(ccp,2);


% Generate data 
n_decision=zeros(K,J+1);
for x=1:K
    n_decision(x,:)=mnrnd(n_large,ccp(x,:));
end 

%n_decision=n_large*ccp;
end 
