
% X can be a vector 
function [lpdf,glpdf,g2lpdf] = normalDistGrad(X,Mu,Sigma)

Z = (X - Mu)./Sigma;
lpdf = sum(-log(Sigma) - .5*log(2*pi) - .5*(Z.^2));
glpdf = -Z./Sigma;

g2lpdf=-(1./Sigma.^2).*eye(length(X));

end