function [shape_gamma,scale_gamma,...
    mean_mu,cov_mu_vec,...
    mean_s_comp,cov_s_comp]=comp_mean_var(map,hessian,J)

mean_gamma  = map(1);
mean_mu     = map(2:J+1);
mean_s_comp = map(end);

cov_gamma   = 1/hessian(1,1);
cov_mu_vec  = inv( hessian(2:J+1,2:J+1) ); 
cov_s_comp  = 1/hessian(end,end);

shape_gamma = mean_gamma^2/cov_gamma;
scale_gamma = cov_gamma/mean_gamma;


end 