function cons=consumption(x,d,prices,phi)
%PC=0.5;;L=1;phi1=5;phi2=0.1;phi=[phi1,phi2];prices=[Y,PC,L];

t=x(1);
a=x(3);
Y=prices(1);
PC=prices(2);
L=prices(3);
phi1=phi(1);
phi2=phi(2);

a_new=a+(d==2 | d==3);
Phi = exp(phi1+phi2*a_new) / ( 1+ exp(phi1+phi2*a_new) );
%Phi=1;
medical_cost=PC*(d==1 | d==3);

% Income 
if t==0 %well 
    income=Y;
elseif d==2||d==3 %no work 
    income=Y*L*Phi;
elseif d==0||d==1 %work 
    income=Y;
end 
% Medical cost 
if t==0 %well 
    medical_cost=0;
elseif d==1||d==3 %treatment 
    medical_cost=PC;
elseif d==0||d==2 %no treatment 
    medical_cost=0;
end 
 
cons=income-medical_cost;
end 