% Generate data sequentially

function n_decision=gen_data_seq_gilleskie(N,T,G0,G1,G2,G3,ccp_true)
J=3;
K=1+sum( (1:1:T).^2 );

%N=100;% Num of episodes
x_mat=zeros(T,N);
d_mat=zeros(T,N);
%start=1;finish=T;
for i=1:N

% One illness episode t=1,...,T
x_vec=zeros(T,1);
d_vec=zeros(T,1);

x_vec(1)=2;
d_vec(1)=randsample(0:1:J,1,'true',ccp_true(x_vec(1),:));     

for t=2:T
% generate state    
x_vec(t)=next_state(x_vec(t-1),d_vec(t-1),G0,G1,G2,G3);      
% generate decision    
d_vec(t)=randsample(0:1:J,1,'true',ccp_true(x_vec(t),:));     
end 
 x_mat(:,i)=x_vec;
 d_mat(:,i)=d_vec;
 
%x_all(start:finish)=x_vec;%d_all(start:finish)=d_vec;%start=start+T;%finish=finish+T;
end 

x_all=reshape(x_mat,N*T,1);
d_all=reshape(d_mat,N*T,1);


n_decision=zeros(K,4);
for j=1:4
    for s=1:K
    n_decision(s,j)=sum(d_all==j-1 & x_all==s);
    end 
end 

end 




