% omega_l = gamma_l / sum_{k=1}^m gamma_k 
% 
function alpha=gamma_to_alpha(gamma)
m=length(gamma);
% 1. From gamma to omega 
omega=gamma./sum(gamma);

% 2. From omega to alpha
alpha = zeros(m-1,1);
for k=1:m-1
    alpha(k) = log(omega(k))-log( omega(m) );
end 

end 