function [s,omega_mu] = comp_s_omegamu_gilleskie(omega, mu, sigma)

omega_mu=mu*omega;
mu_minus_x1 = mu(1,:) - omega_mu(1);% location parameter for -X1
median_x1 = comp_quantile_minus_evmix(omega, mu_minus_x1, sigma, 0.5, 0.9);
e_x1 = comp_trnct_int_minus_evmix(omega,mu_minus_x1,sigma,median_x1);
s = log(2)/e_x1;
end 