% [x,t,v,a] matrix 
% t=0,1,...,T
% v=0,...,T-1
% a=0,...,T-1
% clear;T=2
function x_tva=construct_x_tva(T)

K=1+1+sum( (2:1:T).^2 );
x_tva=zeros(K,4);
% x=1 corresponds to (0,0,0) 
% x=2 corresponds to (1,0,0)
x_tva(1,:)=[1,0,0,0];
x_tva(2,:)=[2,1,0,0];

ind=3;
for t=2:T
for v=0:t-1
    for a=0:t-1
        x=find_x(t,v,a);
        x_tva(ind,:)=[x,t,v,a];
        ind=ind+1;
    end 
end 
end 

end 
