% Computes tau_theta(Q)
% i.e. it does one-step iteration on Emax
function Q1=comp_tau(Q,u_mat,G,mu,sigma,omega,beta)
K=size(u_mat,1);Nd=size(u_mat,2);
v_mat = u_mat +beta * reshape(G*Q,K,Nd);   
[A,a] = comp_as(v_mat,mu,sigma,omega);
Q1=( modify_expint_exp_minus(a) + A )' * (sigma.*omega);
end 