% Define 
% chi_{1:m-1}=( gamma_{1:m-1}, mu_{1:J,1:m-1},sigma_{1:m-1} ) and 
% chi_{m}=( gamma_{m}, mu_{1:J,m}, s_comp_m  )  

function [gamma_new,mu_vec_new,s_comp_new,...
    gamma_removed,mu_vec_removed,s_comp_removed]=remove_chi_m(which_comp_to_remove,gamma_now,mu_now,s_comp_now)
[J,m]=size(mu_now);

if which_comp_to_remove  ~= m %then change the order 
gamma_temp                      = gamma_now(m); 
gamma_now(m)                    = gamma_now(which_comp_to_remove); 
gamma_now(which_comp_to_remove) = gamma_temp; 

mu_temp                         = mu_now(:,m); 
mu_now(:,m)                     = mu_now(:,which_comp_to_remove); 
mu_now(:,which_comp_to_remove)  = mu_temp; 

s_comp_temp                     = s_comp_now(m); 
s_comp_now(m)                   = s_comp_now(which_comp_to_remove); 
s_comp_now(which_comp_to_remove)= s_comp_temp; 
end 

gamma_new       = gamma_now(1:m-1);
gamma_removed   = gamma_now(m);

mu_new          = mu_now(:,1:m-1);mu_vec_new=reshape(mu_new',(m-1)*J,1);
mu_vec_removed  = mu_now(:,m);

s_comp_new      = s_comp_now(1:m-1);
s_comp_removed  = s_comp_now(m);

%{

% chi_{m}=( gamma_{m}, mu_{1:J,m}, s_comp_m  )  
    gamma_removed  = gamma_now(which_comp_to_remove);
    mu_vec_removed = mu_now(:,which_comp_to_remove);
    s_comp_removed = s_comp_now(which_comp_to_remove);
    
% chi_{1:m-1}=( gamma_{1:m-1}, mu_{1:J,1:m-1},sigma_{1:m-1} )
    gamma_new   = gamma_now([1:which_comp_to_remove-1 which_comp_to_remove+1:end]);
    mu_new      = mu_now(:, [1:which_comp_to_remove-1 which_comp_to_remove+1:end]);mu_vec_new=reshape(mu_new',(m-1)*J,1);
    s_comp_new = s_comp_now([1:which_comp_to_remove-1 which_comp_to_remove+1:end]);

%}
end 